'Program: 3DM Creator
'Author: Maxim Kakitsev (maksim@freeuk.com)
'Created: May 2001
'_____________________________________________________
'Run this program to create a file with 3D data for
'the main program 3DMand.  When you are asked to enter the path
'for the new file, choose the same folder where the rest of
'downloaded files are.
'_____________________________________________________
' Variables used:  it%  - number of iterations
'                  col% - x coordinate on your screen
'                  row% - y coordinate on your screen
'                  a    - x coordinate on a complex plane
'                  b    - y coordinate on a complex plane
'                  z    - depth value in 3D
'                  l    - color of a pixel
'_____________________________________________________

SCREEN 12
PRINT "This program will create a file 3DM.dat with 3D data for the main program."
PRINT
PRINT "Enter the path for 3DM.dat, including the file name."
PRINT "It's better to enter the same path as for the rest of the files you unzipped."
INPUT path$
CLS
OPEN path$ FOR APPEND AS #1  'puts the path you entered into a file for the future reference
IF LOF(1) <> 0 THEN
  CLOSE #1
  KILL path$
  OPEN path$ FOR APPEND AS #1
END IF
PALETTE 1, 0
it% = 250     'number of iterations (more [better quality]<---->less [faster processing])
col% = 1
  FOR a = 1 TO -2 STEP -.003125
   row% = 1
   FOR b = -1.5 TO 1.5 STEP .003125
    u = 4 * (a * a + b * b): v = u - 2 * a + .25
    IF u + 8 * a + 3.75 < 0 THEN z = it%: GOTO 10
    IF v - SQR(v) + 2 * a - 1 / 2 < 0 THEN z = it%: GOTO 10
    x = a: y = b
    FOR z = 1 TO it%
      u = x ^ 2: v = y ^ 2: w = 2 * x * y
      x = u - v + a: y = w + b
      IF u + v > 16 THEN GOTO 10
    NEXT z
10  l = z MOD 25
    PSET (col% / 2, row% / 2), l
    IF z > 75 THEN z = 75     'this sets the maximum hight of the fractal
    x3D = INT(a * 200): y3D = INT(b * 200)
    PRINT #1, x3D; y3D; z;    'data is written to file in format [x, y, z]
    row% = row% + 1
  NEXT b
  col% = col% + 1
NEXT a
CLOSE #1
PRINT "The file '"; path$; "' is ready!"
END

